<?php
namespace SM\Factory;

use Doctrine\ORM\EntityManager;
use SM\Traits\TQuery;

class Sm00036000MotivoRescisaoFactory {

    use TQuery;

    protected $connection;
    protected $entityManager;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getMotivoRecisao() {
        $sql = "SELECT NRMOTIVORESCISAO, 
                       NRORG, 
                       DSMOTIVORESCISAO, 
                       IDATIVO
                  FROM FCT_MOTIVORESCISAO";
                    
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function salvarMotivos($params) {
        $sql = "INSERT INTO FCT_MOTIVORESCISAO (
                    NRMOTIVORESCISAO, DSMOTIVORESCISAO, NRORG, 
                    IDATIVO,          DTINCLUSAO,       DTULTATU, 
                    NRORGINCLUSAO,    CDOPERINCLUSAO 
                )
                VALUES (
                    :NRMOTIVORESCISAO, :DSMOTIVORESCISAO, :NRORG, 
                    :IDATIVO,          SYSDATE,            SYSDATE, 
                    :NRORGINCLUSAO,    :CDOPERINCLUSAO 
                )";
        
        $this->connection->executeStatement($sql, $params);
    }

    public function editarMotivos($params) {
        $sql = "UPDATE FCT_MOTIVORESCISAO
                   SET IDATIVO          = :IDATIVO, 
                       DSMOTIVORESCISAO = :DSMOTIVORESCISAO, 
                       NRORGULTATU      = :NRORGULTATU, 
                       CDOPERULTATU     = :CDOPERULTATU,
                       DTULTATU         = SYSDATE
                 WHERE NRMOTIVORESCISAO = :NRMOTIVORESCISAO";
        
        $this->connection->executeStatement($sql, $params);
    }

    public function excluirMotivos($parametro) {
        $sql = "DELETE FROM FCT_MOTIVORESCISAO
                 WHERE NRMOTIVORESCISAO IN (".$parametro.")";
         
         $this->connection->executeStatement($sql);
    }
}
?>