<?php
namespace SM\Factory;

use Doctrine\ORM\EntityManager;
use SM\Traits\TQuery;
use SM\Util\Procedure\FctRefMvCcustoContrato;

class centroCustoRelatorioFactory  {

    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getCentroCustoRelatorio() {
        $sql = "SELECT NRSEQCONTRATO,
                    NRSEQMODCONTRA,
                    NMMODCONTRATO,
                    CDOPERRESPONSAVEL,
                    NMOPERADOR,
                    NRCONTRATOFCT,
                    DTAPROVACAO,
                    NRSEQORCAMENTO,
                    NRORCAMENTOMODELO,
                    NMORCAMENTOMODELO,
                    NRORCAMENTO,
                    DTACEITEORCA,
                    NRTIPOORCAMENTO,
                    NMTIPOORCAMENTO,
                    IDTPFATURA,
                    DSTPFATURA,
                    IDSITUACAOCONTRATO,
                    NRPARCNEGOCIO,
                    NMPRINCIPALPARC,
                    NMSECUNDARIPARC,
                    NRINSCRICAOPARC,
                    NMITEMCONTRATO,
                    CDSERVORCA,
                    NMSERVORCA,
                    IDELEMENTO,
                    CDCENTCUST,
                    NMCENTCUST,
                    QTMEDIDAITEMCONT,
                    QTMEDIDAVARIAVEL,
                    CDTPMEDIDAVARIAVEL,
                    DSTPMEDIDAVARIAVEL,
                    VRTOTSERVORCA,
                    VRTOTAL_ACR_DESC,
                    IDDELPHI,
                    DTINICOMPET,
                    DTFINCOMPET,
                    QTMEDIDAMEDICAO,
                    VRITEMCONTCOMDESC,
                    NRORG
                FROM FCT_MV_CCUSTO_CONTRATO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getDataUltimaAtualizacaoRelatorioCentroCusto() {
        $sql = "SELECT TO_CHAR(DTULTATUMVCCUSTOCONT, 'DD/MM/YYYY HH24:MI:SS') AS DTULTATUMVCCUSTOCONT FROM fct_parametrogeral";
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }

    public function atualizarView() {
        $procedure = new FctRefMvCcustoContrato($this->connection);
        $procedure->executar();
    }
}