<?php
namespace SM\Service;

use SM\Factory\Sm00016000TipoAnexoFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class Sm00016000TipoAnexoService {

    protected $tipoAnexoFactory;
    protected $environment;
    protected $newCode;

    public function __construct(EntityManager $entityManager, Sm00016000TipoAnexoFactory $tipoAnexoFactory, Environment $environment, NewCode $newCode) {
        $this->connection       = $entityManager->getConnection();
        $this->tipoAnexoFactory = $tipoAnexoFactory;
        $this->environment      = $environment;
        $this->newCode          = $newCode;
    }

    public function getTipoAnexo() {
        return $this->tipoAnexoFactory->getTipoAnexo();
    }

    public function salvarTiposAnexos($params) {
        $this->connection->beginTransaction();

        try {
            $nrorg = $this->environment->getNrorg();
            $operador = $this->environment->getCdOperador();
            foreach ($params["DRG"] as $row) {
                if ($row["NRTIPOANEXO"] != 0) {

                    $parametros = array (
                        "NRTIPOANEXO"   => $row["NRTIPOANEXO"],
                        "IDATIVO"       => $row["IDATIVO"],
                        "NMTIPOANEXO"   => $row['NMTIPOANEXO'],
                        "NRORGULTATU"   => $nrorg,
                        "CDOPERULTATU"  => $operador
                    );

                    $this->tipoAnexoFactory->editarAnexos($parametros);
                } else {
                    $nrtipoanexo = $this->newCode->getCodeByTableName("FCT_TIPOANEXO", $nrorg, 1, 10, true);
                    
                    $parametros = array (
                        "NRTIPOANEXO"    => $nrtipoanexo,
                        "IDATIVO"        => $row['IDATIVO'],
                        "NMTIPOANEXO"    => $row['NMTIPOANEXO'],
                        "NRORG"          => $nrorg,
                        "NRORGINCLUSAO"  => $nrorg,
                        "CDOPERINCLUSAO" => $operador,
                    );
                    
                    $this->tipoAnexoFactory->inserirAnexos($parametros);
                }
            }
            $this->connection->commit();
        } catch(\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }

    public function excluirTipoAnexo($parametro) {
        $param = implode(',' , $parametro["NRS"]);
        $this->tipoAnexoFactory->excluirTipoAnexo($param);
    }
}
?>