/* Tabela FORNECEDOR: Fornecedor*/
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes
              nas colunas que se encontram na tabela FORNECEDOR. */
/* Objetivo: Gerar um log que vai utilizar a tabela Geral de Logs de Operaes para
             registrar as alteraes nas colunas da tabela Fornecedor*/

IF EXISTS(SELECT *
          FROM SYSOBJECTS O, SYSUSERS U
          WHERE O.NAME = 'LOG_SUP_FORNECEDOR'  AND
                TYPE   = 'TR'                  AND
                U.UID  = O.UID                 AND
                U.NAME = USER)
DROP TRIGGER LOG_SUP_FORNECEDOR
GO

CREATE TRIGGER LOG_SUP_FORNECEDOR
ON FORNECEDOR
FOR INSERT, UPDATE, DELETE
AS
   DECLARE @V_TIPO                VARCHAR(1)
   DECLARE @V_DSREMOTEADDR        VARCHAR(15);
   DECLARE @V_DSREMOTEHOST        VARCHAR(15);
   DECLARE @V_DSSERVERRDM         VARCHAR(20);
   DECLARE @V_DSSERVMETHOD        VARCHAR(30);
   DECLARE @V_DSREMOTEOPER        VARCHAR(12);
   DECLARE @V_DESC                VARCHAR(500);
   DECLARE @V_CDFILLOGOPER        VARCHAR(4);
   DECLARE @V_ITPESQ              VARCHAR(40);
   DECLARE @V_NMOPERADOR          VARCHAR(40);

   /*VARIAVEIS DO C_CURSOR*/
   DECLARE @V_IDCOMANDO        VARCHAR(1);
   DECLARE @V_NEW_CDFORNECED   VARCHAR(21)
   DECLARE @V_NEW_NRINSJURFORN VARCHAR(20);
   DECLARE @V_NEW_CDTPBAIXAPAG VARCHAR(2);
   DECLARE @V_NEW_IDTIPOFORN   VARCHAR(1);
   DECLARE @V_NEW_CDCSTDIG1ENT VARCHAR(1);
   DECLARE @V_NEW_NMFANTFORN   VARCHAR(40);
   DECLARE @V_NEW_NMRAZSOCFORN VARCHAR(40);
   DECLARE @V_NEW_IDENDEMISFOR VARCHAR(1);
   DECLARE @V_NEW_IDENDCFOPFOR VARCHAR(1);
   DECLARE @V_NEW_IDTPDESCFORN VARCHAR(1);
   DECLARE @V_NEW_VRPEDESCFORN FLOAT;
   DECLARE @V_NEW_IDTPFRETFORN VARCHAR(1);
   DECLARE @V_NEW_IDSITUCADA   VARCHAR(1);
   DECLARE @V_NEW_CDQUALIF     VARCHAR(2);
   DECLARE @V_NEW_DTVALQUALIF  DATE;
   DECLARE @V_NEW_CDFORMPGTO   VARCHAR(2);
   DECLARE @V_NEW_IDTPFORPGTFO VARCHAR(1);
   DECLARE @V_NEW_NRPARCPGTOFO INTEGER;
   DECLARE @V_NEW_NRDIAPGFIXFO INTEGER;
   DECLARE @V_NEW_IDUTDIAPGTFO VARCHAR(1);
   DECLARE @V_NEW_CDTIPCOB     VARCHAR(2);
   DECLARE @V_NEW_VRMINAUTFOR  FLOAT;
   DECLARE @V_NEW_QTMINAUTFOT  FLOAT;
   DECLARE @V_NEW_SGUNIDADE    VARCHAR(10);
   DECLARE @V_NEW_IDGERAFDTENT VARCHAR(1);
   DECLARE @V_NEW_NRITEMAF     INTEGER;
   DECLARE @V_NEW_IDGERCONTPGT VARCHAR(1);
   DECLARE @V_NEW_VRPERPIFORN  FLOAT;
   DECLARE @V_NEW_DSEMAILCOT   VARCHAR(100);
   DECLARE @V_NEW_IDUTILZIPAF  VARCHAR(1);
   DECLARE @V_NEW_IDTPENVAFFOR VARCHAR(1);
   DECLARE @V_NEW_IDUTILEDINF  VARCHAR(1);
   DECLARE @V_NEW_IDOBRIGAEAN  VARCHAR(1);
   DECLARE @V_NEW_VRFRETEFORN  FLOAT;
   DECLARE @V_NEW_CDCONTCTBL   VARCHAR(20);
   DECLARE @V_NEW_CDGRUPOFISC  VARCHAR(3);
   DECLARE @V_NEW_CDAJUCTPAG   VARCHAR(4);
   DECLARE @V_NEW_DTINIVRPDESC DATE;
   DECLARE @V_NEW_IDFORNIMPXML VARCHAR(1);

   DECLARE @V_OLD_CDFORNECED   VARCHAR(21)
   DECLARE @V_OLD_NRINSJURFORN VARCHAR(20);
   DECLARE @V_OLD_CDTPBAIXAPAG VARCHAR(2);
   DECLARE @V_OLD_IDTIPOFORN   VARCHAR(1);
   DECLARE @V_OLD_CDCSTDIG1ENT VARCHAR(1);
   DECLARE @V_OLD_NMFANTFORN   VARCHAR(40);
   DECLARE @V_OLD_NMRAZSOCFORN VARCHAR(40);
   DECLARE @V_OLD_IDENDEMISFOR VARCHAR(1);
   DECLARE @V_OLD_IDENDCFOPFOR VARCHAR(1);
   DECLARE @V_OLD_IDTPDESCFORN VARCHAR(1);
   DECLARE @V_OLD_VRPEDESCFORN FLOAT;
   DECLARE @V_OLD_IDTPFRETFORN VARCHAR(1);
   DECLARE @V_OLD_IDSITUCADA   VARCHAR(1);
   DECLARE @V_OLD_CDQUALIF     VARCHAR(2);
   DECLARE @V_OLD_DTVALQUALIF  DATE;
   DECLARE @V_OLD_CDFORMPGTO   VARCHAR(2);
   DECLARE @V_OLD_IDTPFORPGTFO VARCHAR(1);
   DECLARE @V_OLD_NRPARCPGTOFO INTEGER;
   DECLARE @V_OLD_NRDIAPGFIXFO INTEGER;
   DECLARE @V_OLD_IDUTDIAPGTFO VARCHAR(1);
   DECLARE @V_OLD_CDTIPCOB     VARCHAR(2);
   DECLARE @V_OLD_VRMINAUTFOR  FLOAT;
   DECLARE @V_OLD_QTMINAUTFOT  FLOAT;
   DECLARE @V_OLD_SGUNIDADE    VARCHAR(10);
   DECLARE @V_OLD_IDGERAFDTENT VARCHAR(1);
   DECLARE @V_OLD_NRITEMAF     INTEGER;
   DECLARE @V_OLD_IDGERCONTPGT VARCHAR(1);
   DECLARE @V_OLD_VRPERPIFORN  FLOAT;
   DECLARE @V_OLD_DSEMAILCOT   VARCHAR(100);
   DECLARE @V_OLD_IDUTILZIPAF  VARCHAR(1);
   DECLARE @V_OLD_IDTPENVAFFOR VARCHAR(1);
   DECLARE @V_OLD_IDUTILEDINF  VARCHAR(1);
   DECLARE @V_OLD_IDOBRIGAEAN  VARCHAR(1);
   DECLARE @V_OLD_VRFRETEFORN  FLOAT;
   DECLARE @V_OLD_CDCONTCTBL   VARCHAR(20);
   DECLARE @V_OLD_CDGRUPOFISC  VARCHAR(3);
   DECLARE @V_OLD_CDAJUCTPAG   VARCHAR(4);
   DECLARE @V_OLD_DTINIVRPDESC DATE;       
   DECLARE @V_OLD_IDFORNIMPXML VARCHAR(1);

BEGIN
   /* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   SET @V_TIPO         = '0';
   SET @V_DESC         = '';
   SET @V_ITPESQ       = '';
   SET @V_NMOPERADOR   = '';
   SET @V_CDFILLOGOPER = '';

   EXEC NMUSUARIO  @V_NMOPERADOR;
   EXEC WEBTUNNING @V_DSREMOTEADDR,
                   @V_DSREMOTEHOST,
                   @V_DSSERVERRDM,
                   @V_DSSERVMETHOD,
                   @V_DSREMOTEOPER;

   DECLARE C_CURSOR CURSOR FOR
      SELECT 'D' IDCOMANDO,
             CDFORNECED,
             NRINSJURFORN,
             CDTPBAIXAPAG,
             IDTIPOFORN,
             CDCSTDIG1ENT,
             NMFANTFORN,
             NMRAZSOCFORN,
             IDENDEMISFOR,
             IDENDCFOPFOR,
             IDTPDESCFORN,
             VRPEDESCFORN,
             IDTPFRETFORN,
             IDSITUCADA,
             CDQUALIF,
             DTVALQUALIF,
             CDFORMPGTO,
             IDTPFORPGTFO,
             NRPARCPGTOFO,
             NRDIAPGFIXFO,
             IDUTDIAPGTFO,
             CDTIPCOB,
             VRMINAUTFOR,
             QTMINAUTFOT,
             SGUNIDADE,
             IDGERAFDTENT,
             NRITEMAF,
             IDGERCONTPGT,
             VRPERPIFORN,
             DSEMAILCOT,
             IDUTILZIPAF,
             IDTPENVAFFOR,
             IDUTILEDINF,
             IDOBRIGAEAN,
             VRFRETEFORN,
             CDCONTCTBL,
             CDGRUPOFISC,
             CDAJUCTPAG,
             DTINIVRPDESC,
             IDFORNIMPXML,

             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL
      FROM
         DELETED
      WHERE
         CDFORNECED NOT IN (SELECT CDFORNECED FROM INSERTED)
      UNION ALL

      SELECT 'U' IDCOMANDO,
             DELETED.CDFORNECED,
             DELETED.NRINSJURFORN,
             DELETED.CDTPBAIXAPAG,
             DELETED.IDTIPOFORN,
             DELETED.CDCSTDIG1ENT,
             DELETED.NMFANTFORN,
             DELETED.NMRAZSOCFORN,
             DELETED.IDENDEMISFOR,
             DELETED.IDENDCFOPFOR,
             DELETED.IDTPDESCFORN,
             DELETED.VRPEDESCFORN,
             DELETED.IDTPFRETFORN,
             DELETED.IDSITUCADA,
             DELETED.CDQUALIF,
             DELETED.DTVALQUALIF,
             DELETED.CDFORMPGTO,
             DELETED.IDTPFORPGTFO,
             DELETED.NRPARCPGTOFO,
             DELETED.NRDIAPGFIXFO,
             DELETED.IDUTDIAPGTFO,
             DELETED.CDTIPCOB,
             DELETED.VRMINAUTFOR,
             DELETED.QTMINAUTFOT,
             DELETED.SGUNIDADE,
             DELETED.IDGERAFDTENT,
             DELETED.NRITEMAF,
             DELETED.IDGERCONTPGT,
             DELETED.VRPERPIFORN,
             DELETED.DSEMAILCOT,
             DELETED.IDUTILZIPAF,
             DELETED.IDTPENVAFFOR,
             DELETED.IDUTILEDINF,
             DELETED.IDOBRIGAEAN,
             DELETED.VRFRETEFORN,
             DELETED.CDCONTCTBL,
             DELETED.CDGRUPOFISC,
             DELETED.CDAJUCTPAG,
             DELETED.DTINIVRPDESC,
             DELETED.IDFORNIMPXML,

             INSERTED.CDFORNECED,
             INSERTED.NRINSJURFORN,
             INSERTED.CDTPBAIXAPAG,
             INSERTED.IDTIPOFORN,
             INSERTED.CDCSTDIG1ENT,
             INSERTED.NMFANTFORN,
             INSERTED.NMRAZSOCFORN,
             INSERTED.IDENDEMISFOR,
             INSERTED.IDENDCFOPFOR,
             INSERTED.IDTPDESCFORN,
             INSERTED.VRPEDESCFORN,
             INSERTED.IDTPFRETFORN,
             INSERTED.IDSITUCADA,
             INSERTED.CDQUALIF,
             INSERTED.DTVALQUALIF,
             INSERTED.CDFORMPGTO,
             INSERTED.IDTPFORPGTFO,
             INSERTED.NRPARCPGTOFO,
             INSERTED.NRDIAPGFIXFO,
             INSERTED.IDUTDIAPGTFO,
             INSERTED.CDTIPCOB,
             INSERTED.VRMINAUTFOR,
             INSERTED.QTMINAUTFOT,
             INSERTED.SGUNIDADE,
             INSERTED.IDGERAFDTENT,
             INSERTED.NRITEMAF,
             INSERTED.IDGERCONTPGT,
             INSERTED.VRPERPIFORN,
             INSERTED.DSEMAILCOT,
             INSERTED.IDUTILZIPAF,
             INSERTED.IDTPENVAFFOR,
             INSERTED.IDUTILEDINF,
             INSERTED.IDOBRIGAEAN,
             INSERTED.VRFRETEFORN,
             INSERTED.CDCONTCTBL,
             INSERTED.CDGRUPOFISC,
             INSERTED.CDAJUCTPAG,
             INSERTED.DTINIVRPDESC,
             INSERTED.IDFORNIMPXML
      FROM
         INSERTED, DELETED
      WHERE
         INSERTED.CDFORNECED = DELETED.CDFORNECED
      UNION ALL

      SELECT 'I' IDCOMANDO,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,

             CDFORNECED,
             NRINSJURFORN,
             CDTPBAIXAPAG,
             IDTIPOFORN,
             CDCSTDIG1ENT,
             NMFANTFORN,
             NMRAZSOCFORN,
             IDENDEMISFOR,
             IDENDCFOPFOR,
             IDTPDESCFORN,
             VRPEDESCFORN,
             IDTPFRETFORN,
             IDSITUCADA,
             CDQUALIF,
             DTVALQUALIF,
             CDFORMPGTO,
             IDTPFORPGTFO,
             NRPARCPGTOFO,
             NRDIAPGFIXFO,
             IDUTDIAPGTFO,
             CDTIPCOB,
             VRMINAUTFOR,
             QTMINAUTFOT,
             SGUNIDADE,
             IDGERAFDTENT,
             NRITEMAF,
             IDGERCONTPGT,
             VRPERPIFORN,
             DSEMAILCOT,
             IDUTILZIPAF,
             IDTPENVAFFOR,
             IDUTILEDINF,
             IDOBRIGAEAN,
             VRFRETEFORN,
             CDCONTCTBL,
             CDGRUPOFISC,
             CDAJUCTPAG,
             DTINIVRPDESC,
             IDFORNIMPXML
      FROM INSERTED
      WHERE CDFORNECED NOT IN (SELECT CDFORNECED FROM DELETED);

      OPEN C_CURSOR;
      FETCH NEXT FROM C_CURSOR INTO @V_IDCOMANDO,
                                    @V_OLD_CDFORNECED,   @V_OLD_NRINSJURFORN, @V_OLD_CDTPBAIXAPAG, @V_OLD_IDTIPOFORN,
                                    @V_OLD_CDCSTDIG1ENT, @V_OLD_NMFANTFORN,   @V_OLD_NMRAZSOCFORN, @V_OLD_IDENDEMISFOR,
                                    @V_OLD_IDENDCFOPFOR, @V_OLD_IDTPDESCFORN, @V_OLD_VRPEDESCFORN, @V_OLD_IDTPFRETFORN,
                                    @V_OLD_IDSITUCADA,   @V_OLD_CDQUALIF,     @V_OLD_DTVALQUALIF,  @V_OLD_CDFORMPGTO,
                                    @V_OLD_IDTPFORPGTFO, @V_OLD_NRPARCPGTOFO, @V_OLD_NRDIAPGFIXFO, @V_OLD_IDUTDIAPGTFO,
                                    @V_OLD_CDTIPCOB,     @V_OLD_VRMINAUTFOR,  @V_OLD_QTMINAUTFOT,  @V_OLD_SGUNIDADE,
                                    @V_OLD_IDGERAFDTENT, @V_OLD_NRITEMAF,     @V_OLD_IDGERCONTPGT, @V_OLD_VRPERPIFORN,
                                    @V_OLD_DSEMAILCOT,   @V_OLD_IDUTILZIPAF,  @V_OLD_IDTPENVAFFOR, @V_OLD_IDUTILEDINF,
                                    @V_OLD_IDOBRIGAEAN,  @V_OLD_VRFRETEFORN,  @V_OLD_CDCONTCTBL,   @V_OLD_CDGRUPOFISC,
                                    @V_OLD_CDAJUCTPAG,   @V_OLD_DTINIVRPDESC, @V_OLD_IDFORNIMPXML,

                                    @V_NEW_CDFORNECED,   @V_NEW_NRINSJURFORN, @V_NEW_CDTPBAIXAPAG, @V_NEW_IDTIPOFORN,
                                    @V_NEW_CDCSTDIG1ENT, @V_NEW_NMFANTFORN,   @V_NEW_NMRAZSOCFORN, @V_NEW_IDENDEMISFOR,
                                    @V_NEW_IDENDCFOPFOR, @V_NEW_IDTPDESCFORN, @V_NEW_VRPEDESCFORN, @V_NEW_IDTPFRETFORN,
                                    @V_NEW_IDSITUCADA,   @V_NEW_CDQUALIF,     @V_NEW_DTVALQUALIF,  @V_NEW_CDFORMPGTO,
                                    @V_NEW_IDTPFORPGTFO, @V_NEW_NRPARCPGTOFO, @V_NEW_NRDIAPGFIXFO, @V_NEW_IDUTDIAPGTFO,
                                    @V_NEW_CDTIPCOB,     @V_NEW_VRMINAUTFOR,  @V_NEW_QTMINAUTFOT,  @V_NEW_SGUNIDADE,
                                    @V_NEW_IDGERAFDTENT, @V_NEW_NRITEMAF,     @V_NEW_IDGERCONTPGT, @V_NEW_VRPERPIFORN,
                                    @V_NEW_DSEMAILCOT,   @V_NEW_IDUTILZIPAF,  @V_NEW_IDTPENVAFFOR, @V_NEW_IDUTILEDINF,
                                    @V_NEW_IDOBRIGAEAN,  @V_NEW_VRFRETEFORN,  @V_NEW_CDCONTCTBL,   @V_NEW_CDGRUPOFISC,
                                    @V_NEW_CDAJUCTPAG,   @V_NEW_DTINIVRPDESC, @V_NEW_IDFORNIMPXML;
      WHILE (@@FETCH_STATUS = 0) BEGIN
         IF @V_IDCOMANDO = 'D' BEGIN /*DELETING*/
            IF @V_OLD_CDFORNECED IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' CdForneced=' + @V_OLD_CDFORNECED;
            END;

            IF @V_OLD_NRINSJURFORN IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' InscJurdica=' + @V_OLD_NRINSJURFORN;
            END;

            IF @V_OLD_CDTPBAIXAPAG IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' CdTpBaixaPgar=' + @V_OLD_CDTPBAIXAPAG;
            END;

            IF @V_OLD_IDTIPOFORN IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' IdTpForne=' + @V_OLD_IDTIPOFORN;
            END;

            IF @V_OLD_CDCSTDIG1ENT IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Cd1DigCST=' + @V_OLD_CDCSTDIG1ENT;
            END;

            IF @V_OLD_NMFANTFORN IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' NmFantasia=' + @V_OLD_NMFANTFORN;
            END;

            IF @V_OLD_NMRAZSOCFORN IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' NmRazSocial=' + @V_OLD_NMRAZSOCFORN;
            END;

            IF @V_OLD_IDENDEMISFOR IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' IdEndEmissao=' + @V_OLD_IDENDEMISFOR;
            END;

            IF @V_OLD_IDENDCFOPFOR IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' IdEndCFOP=' + @V_OLD_IDENDCFOPFOR;
            END;

            IF @V_OLD_IDTPDESCFORN IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' TpDescrio=' + @V_OLD_IDTPDESCFORN;
            END;

            IF @V_OLD_VRPEDESCFORN IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Vr%Desconto=' + @V_OLD_VRPEDESCFORN;
            END;

            IF @V_OLD_IDTPFRETFORN IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' TpFrete=' + @V_OLD_IDTPFRETFORN;
            END;

            IF @V_OLD_IDSITUCADA IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Situacao=' + @V_OLD_IDSITUCADA;
            END;

            IF @V_OLD_CDQUALIF IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' CdQualif=' + @V_OLD_CDQUALIF;
            END;

            IF @V_OLD_DTVALQUALIF IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' DtValidQualif=' + CONVERT(VARCHAR,@V_OLD_DTVALQUALIF,103);
            END;

            IF @V_OLD_CDFORMPGTO IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' FormaPgto=' + @V_OLD_CDFORMPGTO;
            END;

            IF @V_OLD_IDTPFORPGTFO IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' TpFormaPgto=' + @V_OLD_IDTPFORPGTFO;
            END;

            IF @V_OLD_NRPARCPGTOFO IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' NrParcelaPgto=' + CONVERT(VARCHAR,@V_OLD_NRPARCPGTOFO);
            END;

            IF @V_OLD_NRDIAPGFIXFO IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' DiasPgto=' + CONVERT(VARCHAR,@V_OLD_NRDIAPGFIXFO);
            END;

            IF @V_OLD_IDUTDIAPGTFO IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' UtilDiasPgto=' + @V_OLD_IDUTDIAPGTFO;
            END;

            IF @V_OLD_CDTIPCOB IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' TpCobrana=' + @V_OLD_CDTIPCOB;
            END;

            IF @V_OLD_VRMINAUTFOR IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' VrMinAutForn=' + @V_OLD_VRMINAUTFOR;
            END;

            IF @V_OLD_QTMINAUTFOT IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' QtMinAutForn=' + @V_OLD_QTMINAUTFOT;
            END;

            IF @V_OLD_SGUNIDADE IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Unidade=' + @V_OLD_SGUNIDADE;
            END;

            IF @V_OLD_IDGERAFDTENT IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' GeraAFDtEntr=' + @V_OLD_IDGERAFDTENT;
            END;

            IF @V_OLD_NRITEMAF IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' NrItemAF=' + @V_OLD_NRITEMAF;
            END;

            IF @V_OLD_IDGERCONTPGT IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' GerCtaAPagar=' + @V_OLD_IDGERCONTPGT;
            END;

            IF @V_OLD_VRPERPIFORN IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Vr%PI/DSV=' + @V_OLD_VRPERPIFORN;
            END;

            IF @V_OLD_DSEMAILCOT IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Email=' + @V_OLD_DSEMAILCOT;
            END;

            IF @V_OLD_IDUTILZIPAF IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' UtilEnvioZipAF=' + @V_OLD_IDUTILZIPAF;
            END;

            IF @V_OLD_IDTPENVAFFOR IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' EnvioAF=' + @V_OLD_IDTPENVAFFOR;
            END;

            IF @V_OLD_IDUTILEDINF IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' UtilIntegNF/EDI=' + @V_OLD_IDUTILEDINF;
            END;

            IF @V_OLD_IDOBRIGAEAN IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' ObrigaEAN=' + @V_OLD_IDOBRIGAEAN;
            END;

            IF @V_OLD_VRFRETEFORN IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' VrFrete=' + @V_OLD_VRFRETEFORN;
            END;

            IF @V_OLD_CDCONTCTBL IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' CodCtaCtbl=' + @V_OLD_CDCONTCTBL;
            END;

            IF @V_OLD_CDGRUPOFISC IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' GrupoFiscal=' + @V_OLD_CDGRUPOFISC;
            END;

            IF @V_OLD_CDAJUCTPAG IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' CodTpAjuste=' + @V_OLD_CDAJUCTPAG;
            END;

            IF @V_OLD_DTINIVRPDESC IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' DtInicial=' + CONVERT(VARCHAR,@V_OLD_DTINIVRPDESC,103);
            END;

            IF @V_OLD_IDFORNIMPXML IS NOT NULL BEGIN    
               SET @V_DESC = @V_DESC + ' FornImpXML=' + @V_OLD_IDFORNIMPXML;
            END;

            SET @V_TIPO   = '3';
            SET @V_ITPESQ = @V_OLD_CDFORNECED;
         END
         ELSE IF @V_IDCOMANDO = 'U' BEGIN /*UPDATING*/
            IF (ISNULL(@V_NEW_CDFORNECED,'!')         <> ISNULL(@V_OLD_CDFORNECED,'!'))         OR
               (ISNULL(@V_NEW_NRINSJURFORN,'!')       <> ISNULL(@V_OLD_NRINSJURFORN,'!'))       OR
               (ISNULL(@V_NEW_CDTPBAIXAPAG,'!')       <> ISNULL(@V_OLD_CDTPBAIXAPAG,'!'))       OR
               (ISNULL(@V_NEW_IDTIPOFORN,'!')         <> ISNULL(@V_OLD_IDTIPOFORN,'!'))         OR
               (ISNULL(@V_NEW_CDCSTDIG1ENT,'!')       <> ISNULL(@V_OLD_CDCSTDIG1ENT,'!'))       OR
               (ISNULL(@V_NEW_NMFANTFORN,'!')         <> ISNULL(@V_OLD_NMFANTFORN,'!'))         OR
               (ISNULL(@V_NEW_NMRAZSOCFORN,'!')       <> ISNULL(@V_OLD_NMRAZSOCFORN,'!'))       OR
               (ISNULL(@V_NEW_IDENDEMISFOR,'!')       <> ISNULL(@V_OLD_IDENDEMISFOR,'!'))       OR
               (ISNULL(@V_NEW_IDENDCFOPFOR,'!')       <> ISNULL(@V_OLD_IDENDCFOPFOR,'!'))       OR
               (ISNULL(@V_NEW_IDTPDESCFORN,'!')       <> ISNULL(@V_OLD_IDTPDESCFORN,'!'))       OR
               (ISNULL(@V_NEW_VRPEDESCFORN,0)         <> ISNULL(@V_OLD_VRPEDESCFORN,0))         OR
               (ISNULL(@V_NEW_IDTPFRETFORN,'!')       <> ISNULL(@V_OLD_IDTPFRETFORN,'!'))       OR
               (ISNULL(@V_NEW_IDSITUCADA,'!')         <> ISNULL(@V_OLD_IDSITUCADA,'!'))         OR
               (ISNULL(@V_NEW_CDQUALIF,'!')           <> ISNULL(@V_OLD_CDQUALIF,'!'))           OR
               (ISNULL(@V_NEW_DTVALQUALIF,GETDATE())  <> ISNULL(@V_OLD_DTVALQUALIF,GETDATE()))  OR
               (ISNULL(@V_NEW_CDFORMPGTO,'!')         <> ISNULL(@V_OLD_CDFORMPGTO,'!'))         OR
               (ISNULL(@V_NEW_IDTPFORPGTFO,'!')       <> ISNULL(@V_OLD_IDTPFORPGTFO,'!'))       OR
               (ISNULL(@V_NEW_NRPARCPGTOFO,0)         <> ISNULL(@V_OLD_NRPARCPGTOFO,0))         OR
               (ISNULL(@V_NEW_NRDIAPGFIXFO,0)         <> ISNULL(@V_OLD_NRDIAPGFIXFO,0))         OR
               (ISNULL(@V_NEW_IDUTDIAPGTFO,'!')       <> ISNULL(@V_OLD_IDUTDIAPGTFO,'!'))       OR
               (ISNULL(@V_NEW_CDTIPCOB,'!')           <> ISNULL(@V_OLD_CDTIPCOB,'!'))           OR
               (ISNULL(@V_NEW_VRMINAUTFOR,0)          <> ISNULL(@V_OLD_VRMINAUTFOR,0))          OR
               (ISNULL(@V_NEW_QTMINAUTFOT,0)          <> ISNULL(@V_OLD_QTMINAUTFOT,0))          OR
               (ISNULL(@V_NEW_SGUNIDADE,'!')          <> ISNULL(@V_OLD_SGUNIDADE,'!'))          OR
               (ISNULL(@V_NEW_IDGERAFDTENT,'!')       <> ISNULL(@V_OLD_IDGERAFDTENT,'!'))       OR
               (ISNULL(@V_NEW_NRITEMAF,0)             <> ISNULL(@V_OLD_NRITEMAF,0))             OR
               (ISNULL(@V_NEW_IDGERCONTPGT,'!')       <> ISNULL(@V_OLD_IDGERCONTPGT,'!'))       OR
               (ISNULL(@V_NEW_VRPERPIFORN,0)          <> ISNULL(@V_OLD_VRPERPIFORN,0))          OR
               (ISNULL(@V_NEW_DSEMAILCOT,'!')         <> ISNULL(@V_OLD_DSEMAILCOT,'!'))         OR
               (ISNULL(@V_NEW_IDUTILZIPAF,'!')        <> ISNULL(@V_OLD_IDUTILZIPAF,'!'))        OR
               (ISNULL(@V_NEW_IDTPENVAFFOR,'!')       <> ISNULL(@V_OLD_IDTPENVAFFOR,'!'))       OR
               (ISNULL(@V_NEW_IDUTILEDINF,'!')        <> ISNULL(@V_OLD_IDUTILEDINF,'!'))        OR
               (ISNULL(@V_NEW_IDOBRIGAEAN,'!')        <> ISNULL(@V_OLD_IDOBRIGAEAN,'!'))        OR
               (ISNULL(@V_NEW_VRFRETEFORN,0)          <> ISNULL(@V_OLD_VRFRETEFORN,0))          OR
               (ISNULL(@V_NEW_CDCONTCTBL,'!')         <> ISNULL(@V_OLD_CDCONTCTBL,'!'))         OR
               (ISNULL(@V_NEW_CDGRUPOFISC,'!')        <> ISNULL(@V_OLD_CDGRUPOFISC,'!'))        OR
               (ISNULL(@V_NEW_CDAJUCTPAG,'!')         <> ISNULL(@V_OLD_CDAJUCTPAG,'!'))         OR
               (ISNULL(@V_NEW_DTINIVRPDESC,GETDATE()) <> ISNULL(@V_OLD_DTINIVRPDESC,GETDATE())) OR
               (ISNULL(@V_NEW_IDFORNIMPXML,'!')       <> ISNULL(@V_OLD_IDFORNIMPXML,'!'))        BEGIN

               IF (ISNULL(@V_NEW_CDFORNECED,'!') <> ISNULL(@V_OLD_CDFORNECED,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' CdForneced=' + @V_NEW_CDFORNECED;
               END;

               IF (ISNULL(@V_NEW_NRINSJURFORN,'!') <> ISNULL(@V_OLD_NRINSJURFORN,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' InscJurdica=' + @V_NEW_NRINSJURFORN;
               END;

               IF (ISNULL(@V_NEW_CDTPBAIXAPAG,'!') <> ISNULL(@V_OLD_CDTPBAIXAPAG,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' CdTpBaixaPgar=' + @V_NEW_CDTPBAIXAPAG;
               END;

               IF (ISNULL(@V_NEW_IDTIPOFORN,'!') <> ISNULL(@V_OLD_IDTIPOFORN,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' IdTpForne=' + @V_NEW_IDTIPOFORN;
               END;

               IF (ISNULL(@V_NEW_CDCSTDIG1ENT,'!') <> ISNULL(@V_OLD_CDCSTDIG1ENT,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' Cd1DigCST=' + @V_NEW_CDCSTDIG1ENT;
               END;

               IF (ISNULL(@V_NEW_NMFANTFORN,'!') <> ISNULL(@V_OLD_NMFANTFORN,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' NmFantasia=' + @V_NEW_NMFANTFORN;
               END;

               IF (ISNULL(@V_NEW_NMRAZSOCFORN,'!') <> ISNULL(@V_OLD_NMRAZSOCFORN,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' NmRazSocial=' + @V_NEW_NMRAZSOCFORN;
               END;

               IF (ISNULL(@V_NEW_IDENDEMISFOR,'!') <> ISNULL(@V_OLD_IDENDEMISFOR,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' IdEndEmissao=' + @V_NEW_IDENDEMISFOR;
               END;

               IF (ISNULL(@V_NEW_IDENDCFOPFOR,'!') <> ISNULL(@V_OLD_IDENDCFOPFOR,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' IdEndCFOP=' + @V_NEW_IDENDCFOPFOR;
               END;

               IF (ISNULL(@V_NEW_IDTPDESCFORN,'!') <> ISNULL(@V_OLD_IDTPDESCFORN,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' TpDescrio=' + @V_NEW_IDTPDESCFORN;
               END;

               IF (ISNULL(@V_NEW_VRPEDESCFORN,0) <> ISNULL(@V_OLD_VRPEDESCFORN,0))  BEGIN
                  SET @V_DESC = @V_DESC + ' Vr%Desconto=' + CONVERT(VARCHAR, @V_NEW_VRPEDESCFORN);
               END;

               IF (ISNULL(@V_NEW_IDTPFRETFORN,'!') <> ISNULL(@V_OLD_IDTPFRETFORN,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' TpFrete=' + @V_NEW_IDTPFRETFORN;
               END;

               IF (ISNULL(@V_NEW_IDSITUCADA,'!') <> ISNULL(@V_OLD_IDSITUCADA,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' Situacao=' + @V_NEW_IDSITUCADA;
               END;

               IF (ISNULL(@V_NEW_CDQUALIF,'!') <> ISNULL(@V_OLD_CDQUALIF,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' CdQualif=' + @V_NEW_CDQUALIF;
               END;

               IF (ISNULL(@V_NEW_DTVALQUALIF,GETDATE()) <> ISNULL(@V_OLD_DTVALQUALIF,GETDATE())) BEGIN
                  SET @V_DESC = @V_DESC + ' DtValidQualif=' + CONVERT(VARCHAR, @V_NEW_DTVALQUALIF, 103);
               END;

               IF (ISNULL(@V_NEW_CDFORMPGTO,'!') <> ISNULL(@V_OLD_CDFORMPGTO,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' FormaPgto=' + @V_NEW_CDFORMPGTO;
               END;

               IF (ISNULL(@V_NEW_IDTPFORPGTFO,'!') <> ISNULL(@V_OLD_IDTPFORPGTFO,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' TpFormaPgto=' + @V_NEW_IDTPFORPGTFO;
               END;

               IF (ISNULL(@V_NEW_NRPARCPGTOFO,0) <> ISNULL(@V_OLD_NRPARCPGTOFO,0)) BEGIN
                  SET @V_DESC = @V_DESC + ' NrParcelaPgto=' + CONVERT(VARCHAR, @V_NEW_NRPARCPGTOFO);
               END;

               IF (ISNULL(@V_NEW_NRDIAPGFIXFO,0) <> ISNULL(@V_OLD_NRDIAPGFIXFO,0)) BEGIN
                  SET @V_DESC = @V_DESC + ' DiasPgto=' + CONVERT(VARCHAR, @V_NEW_NRDIAPGFIXFO);
               END;

               IF (ISNULL(@V_NEW_IDUTDIAPGTFO,'!') <> ISNULL(@V_OLD_IDUTDIAPGTFO,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' UtilDiasPgto=' + @V_NEW_IDUTDIAPGTFO;
               END;

               IF (ISNULL(@V_NEW_CDTIPCOB,'!') <> ISNULL(@V_OLD_CDTIPCOB,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' TpCobrana=' + @V_NEW_CDTIPCOB;
               END;

               IF (ISNULL(@V_NEW_VRMINAUTFOR,0) <> ISNULL(@V_OLD_VRMINAUTFOR,0)) BEGIN
                  SET @V_DESC = @V_DESC + ' VrMinAutForn=' + CONVERT(VARCHAR, @V_NEW_VRMINAUTFOR);
               END;

               IF (ISNULL(@V_NEW_QTMINAUTFOT,0) <> ISNULL(@V_OLD_QTMINAUTFOT,0)) BEGIN
                  SET @V_DESC = @V_DESC + ' QtMinAutForn=' + CONVERT(VARCHAR, @V_NEW_QTMINAUTFOT);
               END;

               IF (ISNULL(@V_NEW_SGUNIDADE,'!') <> ISNULL(@V_OLD_SGUNIDADE,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' Unidade=' + @V_NEW_SGUNIDADE;
               END;

               IF (ISNULL(@V_NEW_IDGERAFDTENT,'!') <> ISNULL(@V_OLD_IDGERAFDTENT,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' GeraAFDtEntr=' + @V_NEW_IDGERAFDTENT;
               END;

               IF (ISNULL(@V_NEW_NRITEMAF,0) <> ISNULL(@V_OLD_NRITEMAF,0)) BEGIN
                  SET @V_DESC = @V_DESC + ' NrItemAF=' + CONVERT(VARCHAR, @V_NEW_NRITEMAF);
               END;

               IF (ISNULL(@V_NEW_IDGERCONTPGT,'!') <> ISNULL(@V_OLD_IDGERCONTPGT,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' GerCtaAPagar=' + @V_NEW_IDGERCONTPGT;
               END;

               IF (ISNULL(@V_NEW_VRPERPIFORN,0) <> ISNULL(@V_OLD_VRPERPIFORN,0)) BEGIN
                  SET @V_DESC = @V_DESC + ' Vr%PI/DSV=' + CONVERT(VARCHAR, @V_NEW_VRPERPIFORN);
               END;

               IF (ISNULL(@V_NEW_DSEMAILCOT,'!') <> ISNULL(@V_OLD_DSEMAILCOT,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' Email=' + @V_NEW_DSEMAILCOT;
               END;

               IF (ISNULL(@V_NEW_IDUTILZIPAF,'!') <> ISNULL(@V_OLD_IDUTILZIPAF,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' UtilEnvioZipAF=' + @V_NEW_IDUTILZIPAF;
               END;

               IF(ISNULL(@V_NEW_IDTPENVAFFOR,'!') <> ISNULL(@V_OLD_IDTPENVAFFOR,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' EnvioAF=' + @V_NEW_IDTPENVAFFOR;
               END;

               IF (ISNULL(@V_NEW_IDUTILEDINF,'!') <> ISNULL(@V_OLD_IDUTILEDINF,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' UtilIntegNF/EDI=' + @V_NEW_IDUTILEDINF;
               END;

               IF (ISNULL(@V_NEW_IDOBRIGAEAN,'!') <> ISNULL(@V_OLD_IDOBRIGAEAN,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' ObrigaEAN=' + @V_NEW_IDOBRIGAEAN;
               END;

               IF (ISNULL(@V_NEW_VRFRETEFORN,0) <> ISNULL(@V_OLD_VRFRETEFORN,0)) BEGIN
                  SET @V_DESC = @V_DESC + ' VrFrete=' + CONVERT(VARCHAR, @V_NEW_VRFRETEFORN);
               END;

               IF (ISNULL(@V_NEW_CDCONTCTBL,'!') <> ISNULL(@V_OLD_CDCONTCTBL,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' CodCtaCtbl=' + @V_NEW_CDCONTCTBL;
               END;

               IF (ISNULL(@V_NEW_CDGRUPOFISC,'!') <> ISNULL(@V_OLD_CDGRUPOFISC,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' GrupoFiscal=' + @V_NEW_CDGRUPOFISC;
               END;

               IF (ISNULL(@V_NEW_CDAJUCTPAG,'!') <> ISNULL(@V_OLD_CDAJUCTPAG,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' CodTpAjuste=' + @V_NEW_CDAJUCTPAG;
               END;

               IF (ISNULL(@V_NEW_DTINIVRPDESC,GETDATE()) <> ISNULL(@V_OLD_DTINIVRPDESC,GETDATE())) BEGIN
                  SET @V_DESC = @V_DESC + ' DtInicial=' + CONVERT(VARCHAR, @V_NEW_DTINIVRPDESC, 103);
               END;                                                                                        

               IF (ISNULL(@V_NEW_IDFORNIMPXML,'!') <> ISNULL(@V_OLD_IDFORNIMPXML,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' FornImpXML=' + @V_NEW_IDFORNIMPXML;
               END;

               SET @V_TIPO   = '2';
               SET @V_ITPESQ = @V_OLD_CDFORNECED;
            END;
         END
         ELSE BEGIN /*INSERT*/
            IF (ISNULL(@V_NEW_CDFORNECED,'!') <> ISNULL(@V_OLD_CDFORNECED,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' CdForneced=' + @V_NEW_CDFORNECED;
            END;

            IF (ISNULL(@V_NEW_NRINSJURFORN,'!') <> ISNULL(@V_OLD_NRINSJURFORN,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' InscJurdica=' + @V_NEW_NRINSJURFORN;
            END;

            IF (ISNULL(@V_NEW_CDTPBAIXAPAG,'!') <> ISNULL(@V_OLD_CDTPBAIXAPAG,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' CdTpBaixaPgar=' + @V_NEW_CDTPBAIXAPAG;
            END;

            IF (ISNULL(@V_NEW_IDTIPOFORN,'!') <> ISNULL(@V_OLD_IDTIPOFORN,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' IdTpForne=' + @V_NEW_IDTIPOFORN;
            END;

            IF (ISNULL(@V_NEW_CDCSTDIG1ENT,'!') <> ISNULL(@V_OLD_CDCSTDIG1ENT,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' Cd1DigCST=' + @V_NEW_CDCSTDIG1ENT;
            END;

            IF (ISNULL(@V_NEW_NMFANTFORN,'!') <> ISNULL(@V_OLD_NMFANTFORN,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' NmFantasia=' + @V_NEW_NMFANTFORN;
            END;

            IF (ISNULL(@V_NEW_NMRAZSOCFORN,'!') <> ISNULL(@V_OLD_NMRAZSOCFORN,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' NmRazSocial=' + @V_NEW_NMRAZSOCFORN;
            END;

            IF (ISNULL(@V_NEW_IDENDEMISFOR,'!') <> ISNULL(@V_OLD_IDENDEMISFOR,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' IdEndEmissao=' + @V_NEW_IDENDEMISFOR;
            END;

            IF (ISNULL(@V_NEW_IDENDCFOPFOR,'!') <> ISNULL(@V_OLD_IDENDCFOPFOR,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' IdEndCFOP=' + @V_NEW_IDENDCFOPFOR;
            END;

            IF (ISNULL(@V_NEW_IDTPDESCFORN,'!') <> ISNULL(@V_OLD_IDTPDESCFORN,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' TpDescrio=' + @V_NEW_IDTPDESCFORN;
            END;

            IF (ISNULL(@V_NEW_VRPEDESCFORN,0) <> ISNULL(@V_OLD_VRPEDESCFORN,0))  BEGIN
               SET @V_DESC = @V_DESC + ' Vr%Desconto=' + CONVERT(VARCHAR, @V_NEW_VRPEDESCFORN);
            END;

            IF (ISNULL(@V_NEW_IDTPFRETFORN,'!') <> ISNULL(@V_OLD_IDTPFRETFORN,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' TpFrete=' + @V_NEW_IDTPFRETFORN;
            END;

            IF (ISNULL(@V_NEW_IDSITUCADA,'!') <> ISNULL(@V_OLD_IDSITUCADA,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' Situacao=' + @V_NEW_IDSITUCADA;
            END;

            IF (ISNULL(@V_NEW_CDQUALIF,'!') <> ISNULL(@V_OLD_CDQUALIF,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' CdQualif=' + @V_NEW_CDQUALIF;
            END;

            IF (ISNULL(@V_NEW_DTVALQUALIF,GETDATE()) <> ISNULL(@V_OLD_DTVALQUALIF,GETDATE())) BEGIN
               SET @V_DESC = @V_DESC + ' DtValidQualif=' + CONVERT(VARCHAR, @V_NEW_DTVALQUALIF, 103);
            END;

            IF (ISNULL(@V_NEW_CDFORMPGTO,'!') <> ISNULL(@V_OLD_CDFORMPGTO,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' FormaPgto=' + @V_NEW_CDFORMPGTO;
            END;

            IF (ISNULL(@V_NEW_IDTPFORPGTFO,'!') <> ISNULL(@V_OLD_IDTPFORPGTFO,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' TpFormaPgto=' + @V_NEW_IDTPFORPGTFO;
            END;

            IF (ISNULL(@V_NEW_NRPARCPGTOFO,0) <> ISNULL(@V_OLD_NRPARCPGTOFO,0)) BEGIN
               SET @V_DESC = @V_DESC + ' NrParcelaPgto=' + CONVERT(VARCHAR, @V_NEW_NRPARCPGTOFO);
            END;

            IF (ISNULL(@V_NEW_NRDIAPGFIXFO,0) <> ISNULL(@V_OLD_NRDIAPGFIXFO,0)) BEGIN
               SET @V_DESC = @V_DESC + ' DiasPgto=' + CONVERT(VARCHAR, @V_NEW_NRDIAPGFIXFO);
            END;

            IF (ISNULL(@V_NEW_IDUTDIAPGTFO,'!') <> ISNULL(@V_OLD_IDUTDIAPGTFO,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' UtilDiasPgto=' + @V_NEW_IDUTDIAPGTFO;
            END;

            IF (ISNULL(@V_NEW_CDTIPCOB,'!') <> ISNULL(@V_OLD_CDTIPCOB,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' TpCobrana=' + @V_NEW_CDTIPCOB;
            END;

            IF (ISNULL(@V_NEW_VRMINAUTFOR,0) <> ISNULL(@V_OLD_VRMINAUTFOR,0)) BEGIN
               SET @V_DESC = @V_DESC + ' VrMinAutForn=' + CONVERT(VARCHAR, @V_NEW_VRMINAUTFOR);
            END;

            IF (ISNULL(@V_NEW_QTMINAUTFOT,0) <> ISNULL(@V_OLD_QTMINAUTFOT,0)) BEGIN
               SET @V_DESC = @V_DESC + ' QtMinAutForn=' + CONVERT(VARCHAR, @V_NEW_QTMINAUTFOT);
            END;

            IF (ISNULL(@V_NEW_SGUNIDADE,'!') <> ISNULL(@V_OLD_SGUNIDADE,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' Unidade=' + @V_NEW_SGUNIDADE;
            END;

            IF (ISNULL(@V_NEW_IDGERAFDTENT,'!') <> ISNULL(@V_OLD_IDGERAFDTENT,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' GeraAFDtEntr=' + @V_NEW_IDGERAFDTENT;
            END;

            IF (ISNULL(@V_NEW_NRITEMAF,0) <> ISNULL(@V_OLD_NRITEMAF,0)) BEGIN
               SET @V_DESC = @V_DESC + ' NrItemAF=' + CONVERT(VARCHAR, @V_NEW_NRITEMAF);
            END;

            IF (ISNULL(@V_NEW_IDGERCONTPGT,'!') <> ISNULL(@V_OLD_IDGERCONTPGT,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' GerCtaAPagar=' + @V_NEW_IDGERCONTPGT;
            END;

            IF (ISNULL(@V_NEW_VRPERPIFORN,0) <> ISNULL(@V_OLD_VRPERPIFORN,0)) BEGIN
               SET @V_DESC = @V_DESC + ' Vr%PI/DSV=' + CONVERT(VARCHAR, @V_NEW_VRPERPIFORN);
            END;

            IF (ISNULL(@V_NEW_DSEMAILCOT,'!') <> ISNULL(@V_OLD_DSEMAILCOT,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' Email=' + @V_NEW_DSEMAILCOT;
            END;

            IF (ISNULL(@V_NEW_IDUTILZIPAF,'!') <> ISNULL(@V_OLD_IDUTILZIPAF,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' UtilEnvioZipAF=' + @V_NEW_IDUTILZIPAF;
            END;

            IF(ISNULL(@V_NEW_IDTPENVAFFOR,'!') <> ISNULL(@V_OLD_IDTPENVAFFOR,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' EnvioAF=' + @V_NEW_IDTPENVAFFOR;
            END;

            IF (ISNULL(@V_NEW_IDUTILEDINF,'!') <> ISNULL(@V_OLD_IDUTILEDINF,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' UtilIntegNF/EDI=' + @V_NEW_IDUTILEDINF;
            END;

            IF (ISNULL(@V_NEW_IDOBRIGAEAN,'!') <> ISNULL(@V_OLD_IDOBRIGAEAN,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' ObrigaEAN=' + @V_NEW_IDOBRIGAEAN;
            END;

            IF (ISNULL(@V_NEW_VRFRETEFORN,0) <> ISNULL(@V_OLD_VRFRETEFORN,0)) BEGIN
               SET @V_DESC = @V_DESC + ' VrFrete=' + CONVERT(VARCHAR, @V_NEW_VRFRETEFORN);
            END;

            IF (ISNULL(@V_NEW_CDCONTCTBL,'!') <> ISNULL(@V_OLD_CDCONTCTBL,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' CodCtaCtbl=' + @V_NEW_CDCONTCTBL;
            END;

            IF (ISNULL(@V_NEW_CDGRUPOFISC,'!') <> ISNULL(@V_OLD_CDGRUPOFISC,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' GrupoFiscal=' + @V_NEW_CDGRUPOFISC;
            END;

            IF (ISNULL(@V_NEW_CDAJUCTPAG,'!') <> ISNULL(@V_OLD_CDAJUCTPAG,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' CodTpAjuste=' + @V_NEW_CDAJUCTPAG;
            END;

            IF (ISNULL(@V_NEW_DTINIVRPDESC,GETDATE()) <> ISNULL(@V_OLD_DTINIVRPDESC,GETDATE())) BEGIN
               SET @V_DESC = @V_DESC + ' DtInicial=' + CONVERT(VARCHAR, @V_NEW_DTINIVRPDESC, 103);
            END;                                                                                             

            IF (ISNULL(@V_NEW_IDFORNIMPXML,'!') <> ISNULL(@V_OLD_IDFORNIMPXML,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' FornImpXML=' + @V_NEW_IDFORNIMPXML;
            END;

            SET @V_TIPO   = '1';
            SET @V_ITPESQ = @V_NEW_CDFORNECED;
         END;

         IF @V_TIPO <> '0' BEGIN
            IF NOT @V_DESC IS NULL BEGIN
               SET @V_DESC   = SUBSTRING(@V_DESC, 1, 300);
               INSERT INTO LOGOPERA
                  (NMTABELA,     DTOPERACAO,   NMRESPOPER,  IDTIPOOPER,   DSOPERACAO,  CDPESQITEM,
                   DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
               VALUES
                  ('FORNECEDOR',    GETDATE(),      ISNULL(@V_NMOPERADOR,' '), @V_TIPO,         @V_DESC,
                   @V_ITPESQ,       @V_DSSERVERRDM, @V_DSREMOTEADDR,           @V_DSREMOTEHOST, @V_DSSERVMETHOD,
                   @V_DSREMOTEOPER, @V_CDFILLOGOPER);
            END;
         END;

         FETCH NEXT FROM C_CURSOR INTO @V_IDCOMANDO,
                                    @V_OLD_CDFORNECED,   @V_OLD_NRINSJURFORN, @V_OLD_CDTPBAIXAPAG, @V_OLD_IDTIPOFORN,
                                    @V_OLD_CDCSTDIG1ENT, @V_OLD_NMFANTFORN,   @V_OLD_NMRAZSOCFORN, @V_OLD_IDENDEMISFOR,
                                    @V_OLD_IDENDCFOPFOR, @V_OLD_IDTPDESCFORN, @V_OLD_VRPEDESCFORN, @V_OLD_IDTPFRETFORN,
                                    @V_OLD_IDSITUCADA,   @V_OLD_CDQUALIF,     @V_OLD_DTVALQUALIF,  @V_OLD_CDFORMPGTO,
                                    @V_OLD_IDTPFORPGTFO, @V_OLD_NRPARCPGTOFO, @V_OLD_NRDIAPGFIXFO, @V_OLD_IDUTDIAPGTFO,
                                    @V_OLD_CDTIPCOB,     @V_OLD_VRMINAUTFOR,  @V_OLD_QTMINAUTFOT,  @V_OLD_SGUNIDADE,
                                    @V_OLD_IDGERAFDTENT, @V_OLD_NRITEMAF,     @V_OLD_IDGERCONTPGT, @V_OLD_VRPERPIFORN,
                                    @V_OLD_DSEMAILCOT,   @V_OLD_IDUTILZIPAF,  @V_OLD_IDTPENVAFFOR, @V_OLD_IDUTILEDINF,
                                    @V_OLD_IDOBRIGAEAN,  @V_OLD_VRFRETEFORN,  @V_OLD_CDCONTCTBL,   @V_OLD_CDGRUPOFISC,
                                    @V_OLD_CDAJUCTPAG,   @V_OLD_DTINIVRPDESC, @V_OLD_IDFORNIMPXML,

                                    @V_NEW_CDFORNECED,   @V_NEW_NRINSJURFORN, @V_NEW_CDTPBAIXAPAG, @V_NEW_IDTIPOFORN,
                                    @V_NEW_CDCSTDIG1ENT, @V_NEW_NMFANTFORN,   @V_NEW_NMRAZSOCFORN, @V_NEW_IDENDEMISFOR,
                                    @V_NEW_IDENDCFOPFOR, @V_NEW_IDTPDESCFORN, @V_NEW_VRPEDESCFORN, @V_NEW_IDTPFRETFORN,
                                    @V_NEW_IDSITUCADA,   @V_NEW_CDQUALIF,     @V_NEW_DTVALQUALIF,  @V_NEW_CDFORMPGTO,
                                    @V_NEW_IDTPFORPGTFO, @V_NEW_NRPARCPGTOFO, @V_NEW_NRDIAPGFIXFO, @V_NEW_IDUTDIAPGTFO,
                                    @V_NEW_CDTIPCOB,     @V_NEW_VRMINAUTFOR,  @V_NEW_QTMINAUTFOT,  @V_NEW_SGUNIDADE,
                                    @V_NEW_IDGERAFDTENT, @V_NEW_NRITEMAF,     @V_NEW_IDGERCONTPGT, @V_NEW_VRPERPIFORN,
                                    @V_NEW_DSEMAILCOT,   @V_NEW_IDUTILZIPAF,  @V_NEW_IDTPENVAFFOR, @V_NEW_IDUTILEDINF,
                                    @V_NEW_IDOBRIGAEAN,  @V_NEW_VRFRETEFORN,  @V_NEW_CDCONTCTBL,   @V_NEW_CDGRUPOFISC,
                                    @V_NEW_CDAJUCTPAG,   @V_NEW_DTINIVRPDESC, @V_NEW_IDFORNIMPXML;
   END;
   CLOSE C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_SUP_FORNECEDOR','5.80.xxx';
GO
