/* Tabela COLLAYOUTIMP: TABELA DE COLUNAS DO LAYOUT DE IMPORTAO*/
/* Descrio: A trigger insere registros na tabela LOGOPERAVND a partir de alteraes na tabela COLLAYOUTIMP */
/* Objetivo: Gerar um log que vai registrar as alteraes na TABLAYOUTIMP,
             utilizando a tabela de Logs de Operaes do VND*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_VND_COLLAYOUTIMP' AND
                 TYPE   = 'TR' 	               AND
	              U.UID  = O.UID           AND
	              U.NAME = USER)
DROP TRIGGER LOG_VND_COLLAYOUTIMP
GO


CREATE TRIGGER LOG_VND_COLLAYOUTIMP
ON COLLAYOUTIMP
FOR INSERT, UPDATE, DELETE
AS
  DECLARE @V_DSREMOTEADDR VARCHAR(15);
  DECLARE @V_DSREMOTEHOST VARCHAR(15);
  DECLARE @V_DSSERVERRDM  VARCHAR(20);
  DECLARE @V_DSSERVMETHOD VARCHAR(30);
  DECLARE @V_DSREMOTEOPER VARCHAR(12);
  DECLARE @V_DESC         VARCHAR(500);
  DECLARE @V_ITPESQ       VARCHAR(40);
  DECLARE @V_NMOPERADOR   VARCHAR(40);
  DECLARE @V_IDTIPOOPER   VARCHAR(1);

/*VARIVEIS DO CURSOR C_CURSOR*/

  DECLARE @V_ID_COMANDO    VARCHAR(1);

  DECLARE @V_NEW_CDLAYOUTIMP         VARCHAR(10);
  DECLARE @V_NEW_NRSEQTABELAY        VARCHAR(10);
  DECLARE @V_NEW_IDFUNARQLAY         VARCHAR(3);
  DECLARE @V_NEW_NRSEQCOLULAY        VARCHAR(10);
  DECLARE @V_NEW_NRPOSICOLLAY        numeric(15);
  DECLARE @V_NEW_NRTAMCOLLAY         numeric(15);
  DECLARE @V_NEW_NRCASASDECIM        numeric(15);
  DECLARE @V_NEW_DSDEFACOLLAY        VARCHAR(50);
  DECLARE @V_NEW_IDGERSEQCOLU        VARCHAR(1);
  DECLARE @V_NEW_IDTDADCOLLAY        VARCHAR(1);
  DECLARE @V_NEW_IDGERCODCOLU        VARCHAR(1);
  DECLARE @V_NEW_CDFRMTCOLLAY        VARCHAR(3);
  DECLARE @V_NEW_NMTABELAIMP         VARCHAR(30);
  DECLARE @V_NEW_NMCOLUNAIMP         VARCHAR(30);
  DECLARE @V_NEW_NMCOLUNAAUX         VARCHAR(30);

  DECLARE @V_OLD_CDLAYOUTIMP         VARCHAR(10);
  DECLARE @V_OLD_NRSEQTABELAY        VARCHAR(10);
  DECLARE @V_OLD_IDFUNARQLAY         VARCHAR(3);
  DECLARE @V_OLD_NRSEQCOLULAY        VARCHAR(10);
  DECLARE @V_OLD_NRPOSICOLLAY        numeric(15);
  DECLARE @V_OLD_NRTAMCOLLAY         numeric(15);
  DECLARE @V_OLD_NRCASASDECIM        numeric(15);
  DECLARE @V_OLD_DSDEFACOLLAY        VARCHAR(50);
  DECLARE @V_OLD_IDGERSEQCOLU        VARCHAR(1);
  DECLARE @V_OLD_IDTDADCOLLAY        VARCHAR(1);
  DECLARE @V_OLD_IDGERCODCOLU        VARCHAR(1);
  DECLARE @V_OLD_CDFRMTCOLLAY        VARCHAR(3);
  DECLARE @V_OLD_NMTABELAIMP         VARCHAR(30);
  DECLARE @V_OLD_NMCOLUNAIMP         VARCHAR(30);
  DECLARE @V_OLD_NMCOLUNAAUX         VARCHAR(30);

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   SET @V_DESC   = '';
   SET @V_ITPESQ     = '';
   SET @V_NMOPERADOR = '';
   SET @V_IDTIPOOPER = '';

   EXEC NMUSUARIO @P_NMUSUARIO = @V_NMOPERADOR OUTPUT;
   SET @V_NMOPERADOR = ISNULL(@V_NMOPERADOR, ' ');

   EXEC WEBTUNNING  @P_DSREMOTEADDR = @V_DSREMOTEADDR OUTPUT,
                    @P_DSREMOTEHOST = @V_DSREMOTEHOST OUTPUT,
                    @P_DSSERVERRDM  = @V_DSSERVERRDM OUTPUT,
                    @P_DSSERVMETHOD = @V_DSSERVMETHOD OUTPUT,
                    @P_DSREMOTEOPER = @V_DSREMOTEOPER OUTPUT;

   DECLARE C_CURSOR CURSOR FOR
     SELECT
     'D'   ID_COMANDO,
           NULL,NULL,NULL,NULL,NULL,
	   NULL,NULL,NULL,NULL,NULL,
	   NULL,NULL,NULL,NULL,NULL,
           DELETED.CDLAYOUTIMP,
           DELETED.NRSEQTABELAY,
           DELETED.IDFUNARQLAY,
           DELETED.NRSEQCOLULAY,
           DELETED.NRPOSICOLLAY,
           DELETED.NRTAMCOLLAY,
           DELETED.NRCASASDECIM,
           DELETED.DSDEFACOLLAY,
           DELETED.IDGERSEQCOLU,
           DELETED.IDTDADCOLLAY,
           DELETED.IDGERCODCOLU,
           DELETED.CDFRMTCOLLAY,
           DELETED.NMTABELAIMP,
           DELETED.NMCOLUNAIMP,
           DELETED.NMCOLUNAAUX
     FROM
           DELETED
     WHERE     
           DELETED.CDLAYOUTIMP + DELETED.NRSEQTABELAY + DELETED.IDFUNARQLAY + DELETED.NRSEQCOLULAY     NOT IN (SELECT  CDLAYOUTIMP + NRSEQTABELAY + IDFUNARQLAY + NRSEQCOLULAY FROM INSERTED)
     UNION ALL

     SELECT
     'U'   IDCOMANDO,
           INSERTED.CDLAYOUTIMP,
           INSERTED.NRSEQTABELAY,
           INSERTED.IDFUNARQLAY,
           INSERTED.NRSEQCOLULAY,
           INSERTED.NRPOSICOLLAY,
           INSERTED.NRTAMCOLLAY,
           INSERTED.NRCASASDECIM,
           INSERTED.DSDEFACOLLAY,
           INSERTED.IDGERSEQCOLU,
           INSERTED.IDTDADCOLLAY,
           INSERTED.IDGERCODCOLU,
           INSERTED.CDFRMTCOLLAY,
           INSERTED.NMTABELAIMP,
           INSERTED.NMCOLUNAIMP,
           INSERTED.NMCOLUNAAUX,
           DELETED.CDLAYOUTIMP,
           DELETED.NRSEQTABELAY,
           DELETED.IDFUNARQLAY,
           DELETED.NRSEQCOLULAY,
           DELETED.NRPOSICOLLAY,
           DELETED.NRTAMCOLLAY,
           DELETED.NRCASASDECIM,
           DELETED.DSDEFACOLLAY,
           DELETED.IDGERSEQCOLU,
           DELETED.IDTDADCOLLAY,
           DELETED.IDGERCODCOLU,
           DELETED.CDFRMTCOLLAY,
           DELETED.NMTABELAIMP,
           DELETED.NMCOLUNAIMP,
           DELETED.NMCOLUNAAUX



     FROM
           INSERTED,
           DELETED
     WHERE     
           INSERTED.CDLAYOUTIMP  = DELETED.CDLAYOUTIMP  AND
           INSERTED.NRSEQTABELAY = DELETED.NRSEQTABELAY AND
           INSERTED.IDFUNARQLAY  = DELETED.IDFUNARQLAY  AND
           INSERTED.NRSEQCOLULAY = DELETED.NRSEQCOLULAY

     UNION ALL

     SELECT
     'I'   IDCOMANDO,
           INSERTED.CDLAYOUTIMP,
           INSERTED.NRSEQTABELAY,
           INSERTED.IDFUNARQLAY,
           INSERTED.NRSEQCOLULAY,
           INSERTED.NRPOSICOLLAY,
           INSERTED.NRTAMCOLLAY,
           INSERTED.NRCASASDECIM,
           INSERTED.DSDEFACOLLAY,
           INSERTED.IDGERSEQCOLU,
           INSERTED.IDTDADCOLLAY,
           INSERTED.IDGERCODCOLU,
           INSERTED.CDFRMTCOLLAY,
           INSERTED.NMTABELAIMP,
           INSERTED.NMCOLUNAIMP,
           INSERTED.NMCOLUNAAUX,
           NULL,NULL,NULL,NULL,NULL,
  	   NULL,NULL,NULL,NULL,NULL,
	   NULL,NULL,NULL,NULL,NULL

     FROM
           INSERTED
     WHERE     
           INSERTED.CDLAYOUTIMP + INSERTED.NRSEQTABELAY + INSERTED.IDFUNARQLAY + INSERTED.NRSEQCOLULAY  NOT IN (SELECT CDLAYOUTIMP + NRSEQTABELAY + IDFUNARQLAY + NRSEQCOLULAY  FROM DELETED)

     OPEN C_CURSOR;
     FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                   @V_NEW_CDLAYOUTIMP,@V_NEW_NRSEQTABELAY,@V_NEW_IDFUNARQLAY,@V_NEW_NRSEQCOLULAY,
                                   @V_NEW_NRPOSICOLLAY,@V_NEW_NRTAMCOLLAY,@V_NEW_NRCASASDECIM,@V_NEW_DSDEFACOLLAY,
                                   @V_NEW_IDGERSEQCOLU,@V_NEW_IDTDADCOLLAY,@V_NEW_IDGERCODCOLU,@V_NEW_CDFRMTCOLLAY,
                                   @V_NEW_NMTABELAIMP,@V_NEW_NMCOLUNAIMP,@V_NEW_NMCOLUNAAUX,@V_OLD_CDLAYOUTIMP,
                                   @V_OLD_NRSEQTABELAY,@V_OLD_IDFUNARQLAY,@V_OLD_NRSEQCOLULAY,@V_OLD_NRPOSICOLLAY,
                                   @V_OLD_NRTAMCOLLAY,@V_OLD_NRCASASDECIM,@V_OLD_DSDEFACOLLAY,@V_OLD_IDGERSEQCOLU,
                                   @V_OLD_IDTDADCOLLAY,@V_OLD_IDGERCODCOLU,@V_OLD_CDFRMTCOLLAY,@V_OLD_NMTABELAIMP,
                                   @V_OLD_NMCOLUNAIMP,@V_OLD_NMCOLUNAAUX

    WHILE (@@FETCH_STATUS = 0) BEGIN
    
       IF @V_ID_COMANDO= 'U' /*UPDATE*/ BEGIN
		IF ISNULL(@V_NEW_CDLAYOUTIMP,'NULL') <> ISNULL(@V_OLD_CDLAYOUTIMP,'NULL') BEGIN
			SET @V_DESC  = 'Cd Layout Imp ' + ISNULL(@V_NEW_CDLAYOUTIMP,'' );
		END;
		IF ISNULL(@V_NEW_NRSEQTABELAY,'NULL') <> ISNULL(@V_OLD_NRSEQTABELAY,'NULL') BEGIN
            SET @V_DESC  = ISNULL(@V_DESC,'') + '  Nr Seq da Tabela ' + ISNULL(@V_NEW_NRSEQTABELAY,'');
		END;
		IF ISNULL(@V_NEW_IDFUNARQLAY,'NULL') <> ISNULL(@V_OLD_IDFUNARQLAY,'NULL') BEGIN
            SET @V_DESC  = ISNULL(@V_DESC,'') + '  Id Funo Oper ' + ISNULL(@V_NEW_IDFUNARQLAY,'' );
		END;
		IF ISNULL(@V_NEW_NRSEQCOLULAY,'NULL') <> ISNULL(@V_OLD_NRSEQCOLULAY,'NULL') BEGIN
            SET @V_DESC  = ISNULL(@V_DESC,'') + '  NRSEQCOLULAY ' + ISNULL(@V_NEW_NRSEQCOLULAY,'');
		END;
		IF ISNULL(CONVERT(VARCHAR,@V_NEW_NRPOSICOLLAY),'NULL') <> ISNULL(CONVERT(VARCHAR,@V_OLD_NRPOSICOLLAY),'NULL') BEGIN
            SET @V_DESC  = ISNULL(@V_DESC,'') + '  NRPOSICOLLAY ' + ISNULL(CONVERT(VARCHAR,@V_NEW_NRPOSICOLLAY),'');
		END;
		IF ISNULL(CONVERT(VARCHAR,@V_NEW_NRTAMCOLLAY),'NULL') <> ISNULL(CONVERT(VARCHAR,@V_OLD_NRTAMCOLLAY),'NULL') BEGIN
            SET @V_DESC  = ISNULL(@V_DESC,'') + '  NRTAMCOLLAY ' + ISNULL(CONVERT(VARCHAR,@V_NEW_NRTAMCOLLAY),'' );
		END;
		IF ISNULL(CONVERT(VARCHAR,@V_NEW_NRCASASDECIM),'NULL') <> ISNULL(CONVERT(VARCHAR,@V_OLD_NRCASASDECIM),'NULL') BEGIN
            SET @V_DESC  = ISNULL(@V_DESC,'') + '  NRCASASDECIM ' + ISNULL(CONVERT(VARCHAR,@V_NEW_NRCASASDECIM),'');
		END;
		IF ISNULL(@V_NEW_DSDEFACOLLAY,'NULL') <> ISNULL(@V_OLD_DSDEFACOLLAY,'NULL') BEGIN
            SET @V_DESC  = ISNULL(@V_DESC,'') + '  DSDEFACOLLAY ' + ISNULL(@V_NEW_DSDEFACOLLAY,'');
		END;
		IF ISNULL(@V_NEW_IDGERSEQCOLU,'NULL') <> ISNULL(@V_OLD_IDGERSEQCOLU,'NULL') BEGIN
            SET @V_DESC  = ISNULL(@V_DESC,'') + '  IDGERSEQCOLU ' + ISNULL(@V_NEW_IDGERSEQCOLU,'');
		END;
		IF ISNULL(@V_NEW_IDTDADCOLLAY,'NULL') <> ISNULL(@V_OLD_IDTDADCOLLAY,'NULL') BEGIN
            SET @V_DESC  = ISNULL(@V_DESC,'') + '  IDTDADCOLLAY ' + ISNULL(@V_NEW_IDTDADCOLLAY,'');
		END;
		IF ISNULL(@V_NEW_IDGERCODCOLU,'NULL') <> ISNULL(@V_OLD_IDGERCODCOLU,'NULL') BEGIN
            SET @V_DESC  = ISNULL(@V_DESC,'') + '  IDGERCODCOLU ' + ISNULL(@V_NEW_IDGERCODCOLU,'');
		END;
		IF ISNULL(@V_NEW_CDFRMTCOLLAY,'NULL') <> ISNULL(@V_OLD_CDFRMTCOLLAY,'NULL') BEGIN
            SET @V_DESC  = ISNULL(@V_DESC,'') + '  CDFRMTCOLLAY ' + ISNULL(@V_NEW_CDFRMTCOLLAY,'');
		END;
		IF ISNULL(@V_NEW_NMTABELAIMP,'NULL') <> ISNULL(@V_OLD_NMTABELAIMP,'NULL') BEGIN
            SET @V_DESC  = ISNULL(@V_DESC,'') + '  NMTABELAIMP ' + ISNULL(@V_NEW_NMTABELAIMP,'' );
		END;
		IF ISNULL(@V_NEW_NMCOLUNAIMP,'NULL') <> ISNULL(@V_OLD_NMCOLUNAIMP,'NULL') BEGIN
            SET @V_DESC  = ISNULL(@V_DESC,'') + '  NMCOLUNAIMP ' + ISNULL(@V_NEW_NMCOLUNAIMP,'' );
		END;
		IF ISNULL(@V_NEW_NMCOLUNAAUX,'NULL') <> ISNULL(@V_OLD_NMCOLUNAAUX,'NULL') BEGIN
            SET @V_DESC  = ISNULL(@V_DESC,'') + '  NMCOLUNAAUX ' + ISNULL(@V_NEW_NMCOLUNAAUX,'' );
		END;
        SET @V_IDTIPOOPER = '2';
       END;
       IF @V_ID_COMANDO= 'I' /*INSERO*/ BEGIN
          SET @V_DESC  = 'Cd Layout Imp '     + ISNULL(@V_NEW_CDLAYOUTIMP,'' )    +  ' '  + 
                  'Nr Seq da Tabela '  + ISNULL(@V_NEW_NRSEQTABELAY,'')    +  ' '  + 
                  'Id Funo Oper '    + ISNULL(@V_NEW_IDFUNARQLAY,'' )    +  ' '  + 
                  'NRSEQCOLULAY '      + ISNULL(@V_NEW_NRSEQCOLULAY,'')    +  ' '  + 
                  'NRPOSICOLLAY '      + ISNULL(CONVERT(VARCHAR,@V_NEW_NRPOSICOLLAY),'')    +  ' '  + 
                  'NRTAMCOLLAY '       + ISNULL(CONVERT(VARCHAR,@V_NEW_NRTAMCOLLAY),'' )    +  ' '  + 
                  'NRCASASDECIM '      + ISNULL(CONVERT(VARCHAR,@V_NEW_NRCASASDECIM),'')    +  ' '  + 
                  'DSDEFACOLLAY '      + ISNULL(@V_NEW_DSDEFACOLLAY,'')    +  ' '  + 
                  'IDGERSEQCOLU '      + ISNULL(@V_NEW_IDGERSEQCOLU,'')    +  ' '  + 
                  'IDTDADCOLLAY '      + ISNULL(@V_NEW_IDTDADCOLLAY,'')    +  ' '  + 
                  'IDGERCODCOLU '      + ISNULL(@V_NEW_IDGERCODCOLU,'')    +  ' '  + 
                  'CDFRMTCOLLAY '      + ISNULL(@V_NEW_CDFRMTCOLLAY,'')    +  ' '  + 
                  'NMTABELAIMP '       + ISNULL(@V_NEW_NMTABELAIMP,'' )    +  ' '  + 
                  'NMCOLUNAIMP '       + ISNULL(@V_NEW_NMCOLUNAIMP,'' )    +  ' '  + 
                  'NMCOLUNAAUX '       + ISNULL(@V_NEW_NMCOLUNAAUX,'' );
          SET @V_IDTIPOOPER = '1';
       END;
       IF @V_ID_COMANDO= 'D' /*DELEO*/  BEGIN
          SET @V_DESC  = 'Cd Layout Imp '     + ISNULL(@V_OLD_CDLAYOUTIMP,'' )    +  ' '  + 
                  'Nr Seq da Tabela '  + ISNULL(@V_OLD_NRSEQTABELAY,'')    +  ' '  + 
                  'Id Funo Oper '    + ISNULL(@V_OLD_IDFUNARQLAY,'' )    +  ' '  + 
                  'NRSEQCOLULAY '      + ISNULL(@V_OLD_NRSEQCOLULAY,'')    +  ' '  + 
                  'NRPOSICOLLAY '      + ISNULL(CONVERT(VARCHAR,@V_OLD_NRPOSICOLLAY),'')    +  ' '  + 
                  'NRTAMCOLLAY '       + ISNULL(CONVERT(VARCHAR,@V_OLD_NRTAMCOLLAY),'' )    +  ' '  + 
                  'NRCASASDECIM '      + ISNULL(CONVERT(VARCHAR,@V_OLD_NRCASASDECIM),'')    +  ' '  + 
                  'DSDEFACOLLAY '      + ISNULL(@V_OLD_DSDEFACOLLAY,'')    +  ' '  + 
                  'IDGERSEQCOLU '      + ISNULL(@V_OLD_IDGERSEQCOLU,'')    +  ' '  + 
                  'IDTDADCOLLAY '      + ISNULL(@V_OLD_IDTDADCOLLAY,'')    +  ' '  + 
                  'IDGERCODCOLU '      + ISNULL(@V_OLD_IDGERCODCOLU,'')    +  ' '  + 
                  'CDFRMTCOLLAY '      + ISNULL(@V_OLD_CDFRMTCOLLAY,'')    +  ' '  + 
                  'NMTABELAIMP '       + ISNULL(@V_OLD_NMTABELAIMP,'' )    +  ' '  + 
                  'NMCOLUNAIMP '       + ISNULL(@V_OLD_NMCOLUNAIMP,'' )    +  ' '  + 
                  'NMCOLUNAAUX '       + ISNULL(@V_OLD_NMCOLUNAAUX,'' );
          SET @V_IDTIPOOPER = '3';
       END;
       IF  (@V_IDTIPOOPER <> '') BEGIN
          IF @V_DESC IS NOT NULL BEGIN
             SET @V_ITPESQ =  ISNULL( @V_NEW_CDLAYOUTIMP + @V_NEW_NRSEQTABELAY + @V_NEW_IDFUNARQLAY + @V_NEW_NRSEQCOLULAY , @V_OLD_CDLAYOUTIMP + @V_OLD_NRSEQTABELAY + @V_OLD_IDFUNARQLAY + @V_OLD_NRSEQCOLULAY );
             SET @V_DESC = SUBSTRING(@V_DESC, 1, 300);
             INSERT INTO LOGOPERAVND
                    (NMTABELAVND, DTOPERACAOVND, NMRESPOPERVND, IDTIPOOPERVND, DSOPERACAOVND,
                     CDPESQITEMVND, DSRDMUSUOPERVND, DSENDUSUOPERVND, DSNMUSUOPERVND, DSMETUSUOPERVND,
                     CDORESPOPERVND)
             VALUES ('COLLAYOUTIMP',GETDATE(), ISNULL(@V_NMOPERADOR,' '), @V_IDTIPOOPER, @V_DESC, @V_ITPESQ,
                     @V_DSSERVERRDM, @V_DSREMOTEADDR, @V_DSREMOTEHOST, @V_DSSERVMETHOD, @V_DSREMOTEOPER);
          END;
       END;
       FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                     @V_NEW_CDLAYOUTIMP,@V_NEW_NRSEQTABELAY,@V_NEW_IDFUNARQLAY,@V_NEW_NRSEQCOLULAY,
                                     @V_NEW_NRPOSICOLLAY,@V_NEW_NRTAMCOLLAY,@V_NEW_NRCASASDECIM,@V_NEW_DSDEFACOLLAY,
                                     @V_NEW_IDGERSEQCOLU,@V_NEW_IDTDADCOLLAY,@V_NEW_IDGERCODCOLU,@V_NEW_CDFRMTCOLLAY,
                                     @V_NEW_NMTABELAIMP,@V_NEW_NMCOLUNAIMP,@V_NEW_NMCOLUNAAUX,@V_OLD_CDLAYOUTIMP,
                                     @V_OLD_NRSEQTABELAY,@V_OLD_IDFUNARQLAY,@V_OLD_NRSEQCOLULAY,@V_OLD_NRPOSICOLLAY,
                                     @V_OLD_NRTAMCOLLAY,@V_OLD_NRCASASDECIM,@V_OLD_DSDEFACOLLAY,@V_OLD_IDGERSEQCOLU,
                                     @V_OLD_IDTDADCOLLAY,@V_OLD_IDGERCODCOLU,@V_OLD_CDFRMTCOLLAY,@V_OLD_NMTABELAIMP,
                                     @V_OLD_NMCOLUNAIMP,@V_OLD_NMCOLUNAAUX
    SET @V_DESC   = '';
    END;
    CLOSE      C_CURSOR;
    DEALLOCATE C_CURSOR;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_VND_COLLAYOUTIMP','5.20.001';
GO 