import { ZdPage } from '@zeedhi/vue';

const routes = [
    {
        path: '/auth/login',
        name: 'login',
        component: ZdPage,
        props: {
            path: 'login',
            local: true,
        },
    },
    {
        path: '/',
        name: 'home',
        component: ZdPage,
        props: {
            path: 'home',
            local: true,
        },
    },
    {
        path: '/dashboard',
        name: 'dashboard',
        component: ZdPage,
        props: {
            path: '/dashboard/dashboard',
            local: true,
        },
    },
    {
        path: '/centroCustoRelatorio',
        name: 'Relatorio Centro Custo',
        component: ZdPage,
        props: {
            path: '/centroCustoRelatorio',
            local: true,
        },
    },
    {
        path: '/billingComparison',
        name: 'Billing Comparison',
        component: ZdPage,
        props: {
            path: '/billing/BillingComparison',
            local: true,
        },
    },
    {
        path: '/billingComparisonDetail',
        name: 'Billing Comparison Detail',
        component: ZdPage,
        props: {
            path: '/billing/BillingComparisonDetail',
            local: true,
        },
    },
    {
        path: '/logCallbackCertisign',
        name: 'logCallbackCertisign',
        component: ZdPage,
        props: {
            path: '/CallbackCertisign/logCallbackCertisign',
            local: true,
        },
    },
    {
        path: '/clientesNaoFaturadosRelatorio',
        name: 'clientesNaoFaturadosRelatorio',
        component: ZdPage,
        props: {
            path: '/clientesNaoFaturadosRelatorio',
            local: true,
        },
    },
    {
        path: '/sm_next_00049_000_agrupamento_contratos_faturamento',
        name: 'Agrupamento de Contratos para Faturamento',
        component: ZdPage,
        props: {
            path: '/Faturamento/sm_next_00049_000_agrupamento_contratos_faturamento',
            local: true,
        },
    },
    {
        path: '/sm_next_00006_000_servicos',
        name: 'Serviços',
        component: ZdPage,
        props: {
            path: '/Service/sm_next_00006_000_servicos',
            local: true,
        },
    },
    {
        path: '/sm_00037_000_motivo_negociacao',
        name: 'motivoNegociacao',
        component: ZdPage,
        props: {
            path: '/sm_00037_000_motivo_negociacao',
            local: true,
        },
    },
    {
        path: '/sm_00016_000_tipo_anexo',
        name: 'tipoAnexo',
        component: ZdPage,
        props: {
            path: '/sm_00016_000_tipo_anexo',
            local: true,
        },
    },
    {
        path: '/sm_00004_110_tipo_rescisao',
        name: 'tipoRescisao',
        component: ZdPage,
        props: {
            path: '/sm_00004_110_tipo_rescisao',
            local: true,
        },
    },
    {
        path: '/sm_00036_000_motivo_rescisao',
        name: 'motivoRecisao',
        component: ZdPage,
        props: {
            path: '/sm_00036_000_motivo_rescisao',
            local: true,
        },
    },
    {
        path: '/modules/:module/:page',
        name: 'microservice',
        component: () => import('../views/Microservice.vue'),
    },
    {
        path: '*',
        component: ZdPage,
        props: {
            path: 'notfound',
            local: true,
        },
    },
];

export default routes;
